<template>
  <Modal
    :options="getModalOptions"
    :on-positive-click="handleConfirm"
    :on-negative-click="handleClose"
    :on-close="handleClose"
  >
    <template #Context>
      <n-form
        ref="formRef"
        :model="BoxForm"
        :rules="BoxRules"
        :label-width="80"
        label-placement="left"
        require-mark-placement="left"
        :disabled="disabled"
      >
        <template v-for="(item,index) in getFormOptions" :key="index">
          <n-form-item :label="item.label" :path="item.key">
            <n-input v-if="item.type === 'input'" v-model:value="BoxForm[item.key]" v-bind="item.props" />
          </n-form-item>
        </template>
      </n-form>
    </template>
  </Modal>
</template>

<script>
import { form } from '../tools/form.js'
import { defineComponent, ref, reactive, computed, toRefs } from 'vue'
import { boxCreate, boxUpdate } from '@/api/equipment/box.js'
import Modal from '@/components/Modal/index.vue'
export default defineComponent({
  name: 'BoxModal',
  components: { Modal },
  props: {
    visible: {
      type: Boolean,
      default: false
    },
    type: {
      type: String,
      default: 'create'
    },
    data: {
      type: Object,
      default: () => {}
    }
  },
  emits: {
    'update:visible': null,
    'reload': null
  },
  setup(props, { emit }) {
    const MODAL_TYPE = {
      'create': '新建盒子信息',
      'preview': '盒子详情',
      'update': '编辑盒子信息'
    }
    const { BoxForm, BoxRules } = form
    const formRef = ref()
    const data = reactive({
      BoxForm: {
        ...BoxForm,
        ...props.data
      },
      BoxRules: {
        ...BoxRules
      },
      disabled: props.type === 'preview'
    })

    const getModalOptions = computed(() => {
      return {
        title: MODAL_TYPE[props.type],
        show: props.visible,
        negativeText: '取消',
        positiveText: '确认'
      }
    })

    const getFormOptions = computed(() => {
      return {
        ...form.formItem
      }
    })

    function handleConfirm() {
      formRef.value?.validate((errors) => {
        if (!errors) {
          const params = { ...data.BoxForm }
          if (params.id) {
            /* 编辑 */
            boxUpdate(params)
              .then(res => {
                if (res.code === 0) {
                  emit('reload')
                  handleClose()
                }
              })
          } else {
            /* 新增 */
            boxCreate(params)
              .then(res => {
                if (res.code === 0) {
                  emit('reload')
                  handleClose()
                }
              })
          }
        } else {
          $message.error('请完善必填信息')
        }
      })
    }

    /* 关闭弹窗 */
    const handleClose = () => {
      emit('update:visible', false)
    }

    return {
      ...toRefs(data),
      formRef,
      getModalOptions,
      getFormOptions,
      handleConfirm,
      handleClose
    }
  }
})
</script>
<style scoped lang='scss'>
</style>
